/* ============================================================================
 * Copyright (C) 2004 - Infineon Technologies AG.
 *
 * All rights reserved.
 * ============================================================================
 *
 * ============================================================================
 *
 * This document contains proprietary information belonging to Infineon
 * Technologies AG. Passing on and copying of this document, and communication
 * of its contents is not permitted without prior written authorisation.
 *
 * ============================================================================
 */

/* ===========================================================================
 *
 * File Name    : adslAturPhysTable_access.h
 * Author       : Subbi
 * Date         : 17-Jun-2004
 *
 * ===========================================================================
 *
 * Project      : Amazon
 * Block        : ADSL-MIBs
 *
 * ===========================================================================
 * Contents: This file contains:
 *                 1) User-defined data structure for accessing AturPhysTable
 *                 2) User-defined data access functions for data in table
 *                    adslAturPhysTable
 *                 3) Column accessors functions
 *
 *
 * ===========================================================================
 * References: RFC 2662
 *
 */

/* ===========================================================================
 * Revision History:
 * Subramani: Changes made to return types of get_adslAturCurrSnrMgn
 * get_adslAturCurrStatus and get_adslAturCurrOutputPwr
 * $Log$
 * ===========================================================================
 */


/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.6 2003/09/11 22:48:49 rstory Exp $
 */

#ifndef ADSLATURPHYSTABLE_ACCESS_H
#define ADSLATURPHYSTABLE_ACCESS_H

/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
 */

#include <adslMIB/adslTable_access.h>

/*
 * ===========================================================================
 *                           USER-DEFINED DATA TYPES
 * ===========================================================================
 */

#ifdef STUB_IOCTL
/** User-defined data structure for accessing AturPhysTable **/
typedef struct adslAturPhysEntry {
    int ifIndex;
    char serial_no[32];
    char vendor_id[16];
    char version_no[16];
    int SnrMgn;
    u_int32 Attn;
    u_int32 status;
    int outputPwr;
    u_int32 attainableRate;
    u_char flags;
} adslAturPhysEntry;
#endif


/*
 * ===========================================================================
 *                           FUNCTION PROTOTYPES
 * ===========================================================================
 */

/** User-defined data access functions for data in table adslAturPhysTable */
/** row level accessors */
Netsnmp_First_Data_Point adslAturPhysTable_get_first_data_point;
Netsnmp_Next_Data_Point adslAturPhysTable_get_next_data_point;


/** column accessors */
#if defined(HAVE_OPTIMIZED_CODE)

char  *
get_adslAturInvData(void *data_context, size_t * ret_len,
			unsigned int var);

int *
get_adslAturCurrSNROutputPwr(void *data_context, size_t *ret_len,
				unsigned int var);

u_int32 *
get_adslAturCurrAtnAttainableRate(void *data_context, size_t *ret_len,
				unsigned int var);
#else
char    *get_adslAturInvSerialNumber(void *data_context, size_t * ret_len);
char    *get_adslAturInvVendorID(void *data_context, size_t * ret_len);
char    *get_adslAturInvVersionNumber(void *data_context, size_t * ret_len);
int    *get_adslAturCurrSnrMgn(void *data_context, size_t * ret_len);
u_int32 *get_adslAturCurrAtn(void *data_context, size_t * ret_len);
int    *get_adslAturCurrOutputPwr(void *data_context, size_t * ret_len);
u_int32 *get_adslAturCurrAttainableRate(void *data_context, size_t * ret_len);

#endif

u_int32 *get_adslAturCurrStatus(void *data_context, size_t * ret_len);

#ifndef ENABLE_DRIVER_CALL
int get_adslAturPhysTable1(int Fd2, int GET_adsl_ATUR_PHY2,
                        void *adslAturPhysTable);
#endif

#endif                          /* ADSLATURPHYSTABLE_ACCESS_H */
