/* ============================================================================
 * Copyright (C) 2004 - Infineon Technologies AG.
 *
 * All rights reserved.
 * ============================================================================
 *
 * ============================================================================
 *
 * This document contains proprietary information belonging to Infineon
 * Technologies AG. Passing on and copying of this document, and communication
 * of its contents is not permitted without prior written authorisation.
 *
 * ============================================================================
 */

/* ===========================================================================
 *
 * File Name    :   adslLineAlarmConfProfileTable_checkfns.c
 * Author       :   Subramani
 * Date         :   17-Jun-2004
 *
 * ===========================================================================
 *
 * Project      :   Amazon
 * Block        :   ADSL-MIBs
 *
 * ===========================================================================
 * Contents:    This file is auto-generated and SHOULD NOT BE EDITED by hand.
 *              Modify the adslLineAlarmConfProfileTable_checkfns_local.[ch]
 *              files insead so that you can regenerate this one as mib2c
 *              improvements are made.
 *
 *
 * ===========================================================================
 * References: RFC 2662
 *
 */



/* ===========================================================================
 * Revision History:
 *
 * $Log$
 * ===========================================================================
*/

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.check_values.conf,v 1.6 2003/06/13 18:18:04 hardaker Exp $
 */

/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
*/

/* standard headers */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include "adslLineAlarmConfProfileTable_checkfns.h"
#include "adslLineAlarmConfProfileTable_checkfns_local.h"
#include "adslLineAlarmConfProfileTable_enums.h"

/*
 * ===========================================================================
 *                          LOCAL FUNCTIONS
 * ===========================================================================
*/
#if defined(HAVE_OPTIMIZED_CODE)
int
check_adslThresh15MinVal(int type, long *val, size_t val_len,
                              long *old_val, size_t old_val_len)
{

    int             ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_INTEGER)
        return SNMP_ERR_WRONGTYPE;

    ret = SNMP_ERR_NOERROR;
    /** Check the ranges of the passed value for legality */
    if (!((*val >= 0) && (*val <= 900)))
    return SNMP_ERR_WRONGVALUE;
    
    return SNMP_ERR_NOERROR;
}


int
check_adslThreshChanVal(int type, u_long * val,
                               size_t val_len, u_long * old_val,
                               size_t old_val_len)
{

   int ret;
    
   /** Check to see that we were called legally */
   if (!val)
     return SNMP_ERR_GENERR;
   
    /** Check the incoming type for correctness */
   if (type != ASN_UNSIGNED)
     return SNMP_ERR_WRONGTYPE;
    /** looks ok, call the local version of the same function. */
    return SNMP_ERR_NOERROR;
}
#else
/** Decides if an incoming value for the adslAtucThresh15MinLofs mib node is
    legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_adslAtucThresh15MinLofs(int type, long *val, size_t val_len,
                              long *old_val, size_t old_val_len)
{

    int             ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_INTEGER)
        return SNMP_ERR_WRONGTYPE;

    ret = SNMP_ERR_NOERROR;
    /** Check the ranges of the passed value for legality */
    if (!((*val >= 0) && (*val <= 900)))
    return SNMP_ERR_WRONGVALUE;
    
    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the adslAtucThresh15MinLoss mib node is
    legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
        int
        check_adslAtucThresh15MinLoss(int type, long *val, size_t val_len,
                                      long *old_val, size_t old_val_len) {

        int ret;
    /** Check to see that we were called legally */
        if (!val)
        return SNMP_ERR_GENERR;
    /** Check the incoming type for correctness */
        if (type != ASN_INTEGER)
        return SNMP_ERR_WRONGTYPE; ret = SNMP_ERR_NOERROR;
    /** Check the ranges of the passed value for legality */
        if (!((*val >= 0) && (*val <= 900)))
        return SNMP_ERR_WRONGVALUE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the adslAtucThresh15MinESs mib node is
    legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
                    int
                    check_adslAtucThresh15MinESs(int type, long *val,
                                                 size_t val_len,
                                                 long *old_val,
                                                 size_t old_val_len) {

                    int ret;
    /** Check to see that we were called legally */
                    if (!val)
                    return SNMP_ERR_GENERR;
    /** Check the incoming type for correctness */
                    if (type != ASN_INTEGER)
                    return SNMP_ERR_WRONGTYPE; ret = SNMP_ERR_NOERROR;
    /** Check the ranges of the passed value for legality */
                   if (!((*val >= 0) && (*val <= 900)))
        return SNMP_ERR_WRONGVALUE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the adslAtucThreshFastRateUp mib node is
     legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
                        int
                        check_adslAtucThreshFastRateUp(int type,
                                                       u_long * val,
                                                       size_t val_len,
                                                       u_long * old_val,
                                                       size_t old_val_len)
                        {

                        int ret;
    /** Check to see that we were called legally */
                        if (!val)
                        return SNMP_ERR_GENERR;
    /** Check the incoming type for correctness */
                        if (type != ASN_UNSIGNED)
                        return SNMP_ERR_WRONGTYPE;
    /** looks ok, call the local version of the same function. */
    return SNMP_ERR_NOERROR;
}

                              
/** Decides if an incoming value for the adslAtucThreshInterleaveRateUp mib
    node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
                        int
                        check_adslAtucThreshInterleaveRateUp(int type,
                                                             u_long * val,
                                                             size_t
                                                             val_len,
                                                             u_long *
                                                             old_val,
                                                             size_t
                                                             old_val_len) {

                        int ret;
    /** Check to see that we were called legally */
                        if (!val)
                        return SNMP_ERR_GENERR;
    /** Check the incoming type for correctness */
                        if (type != ASN_UNSIGNED)
                        return SNMP_ERR_WRONGTYPE;
    return SNMP_ERR_NOERROR;
}


/** Decides if an incoming value for the adslAtucThreshFastRateDown mib node
    is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
                        int
                        check_adslAtucThreshFastRateDown(int type,
                                                         u_long * val,
                                                         size_t val_len,
                                                         u_long * old_val,
                                                         size_t
                                                         old_val_len) {

                        int ret;
    /** Check to see that we were called legally */
                        if (!val)
                        return SNMP_ERR_GENERR;
    /** Check the incoming type for correctness */
                        if (type != ASN_UNSIGNED)
                        return SNMP_ERR_WRONGTYPE;
    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the adslAtucThreshInterleaveRateDown mib
    node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
                        int
                        check_adslAtucThreshInterleaveRateDown(int type,
                                                               u_long *
                                                               val,
                                                               size_t
                                                               val_len,
                                                               u_long *
                                                               old_val,
                                                               size_t
                                                               old_val_len)
                        {

                        int ret;
    /** Check to see that we were called legally */
                        if (!val)
                        return SNMP_ERR_GENERR;
    /** Check the incoming type for correctness */
                        if (type != ASN_UNSIGNED)
                        return SNMP_ERR_WRONGTYPE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the adslAturThresh15MinLofs mib node is
    legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
                        int
                        check_adslAturThresh15MinLofs(int type, long *val,
                                                      size_t val_len,
                                                      long *old_val,
                                                      size_t old_val_len) {

                        int ret;
    /** Check to see that we were called legally */
                        if (!val)
                        return SNMP_ERR_GENERR;
    /** Check the incoming type for correctness */
                        if (type != ASN_INTEGER)
                        return SNMP_ERR_WRONGTYPE; ret = SNMP_ERR_NOERROR;
    /** Check the ranges of the passed value for legality */
                       if (!((*val >= 0) && (*val <= 900)))
        return SNMP_ERR_WRONGVALUE;

    return SNMP_ERR_NOERROR;
}


/** Decides if an incoming value for the adslAturThresh15MinLoss mib node is
    legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
                            int
                            check_adslAturThresh15MinLoss(int type,
                                                          long *val,
                                                          size_t val_len,
                                                          long *old_val,
                                                          size_t
                                                          old_val_len) {

                            int ret;
    /** Check to see that we were called legally */
                            if (!val)
                            return SNMP_ERR_GENERR;
    /** Check the incoming type for correctness */
                            if (type != ASN_INTEGER)
                            return SNMP_ERR_WRONGTYPE;
                            ret = SNMP_ERR_NOERROR;
    /** Check the ranges of the passed value for legality */
                           if (!((*val >= 0) && (*val <= 900)))
        return SNMP_ERR_WRONGVALUE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the adslAturThresh15MinLprs mib node is
    legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
                                int
                                check_adslAturThresh15MinLprs(int type,
                                                              long *val,
                                                              size_t
                                                              val_len,
                                                              long
                                                              *old_val,
                                                              size_t
                                                              old_val_len)
                                {

                                int ret;
    /** Check to see that we were called legally */
                                if (!val)
                                return SNMP_ERR_GENERR;
    /** Check the incoming type for correctness */
                                if (type != ASN_INTEGER)
                                return SNMP_ERR_WRONGTYPE;
                                ret = SNMP_ERR_NOERROR;
    /** Check the ranges of the passed value for legality */
                               if (!((*val >= 0) && (*val <= 900)))
        return SNMP_ERR_WRONGVALUE;

    return SNMP_ERR_NOERROR;
}


/** Decides if an incoming value for the adslAturThresh15MinESs mib node is
    legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
                                    int
                                    check_adslAturThresh15MinESs(int type,
                                                                 long *val,
                                                                 size_t
                                                                 val_len,
                                                                 long
                                                                 *old_val,
                                                                 size_t
                                                                 old_val_len)
                                    {

                                    int ret;
    /** Check to see that we were called legally */
                                    if (!val)
                                    return SNMP_ERR_GENERR;
    /** Check the incoming type for correctness */
                                    if (type != ASN_INTEGER)
                                    return SNMP_ERR_WRONGTYPE;
                                    ret = SNMP_ERR_NOERROR;
    /** Check the ranges of the passed value for legality */
                                   if (!((*val >= 0) && (*val <= 900)))
        return SNMP_ERR_WRONGVALUE;

    return SNMP_ERR_NOERROR;
}


/** Decides if an incoming value for the adslAturThreshFastRateUp mib node is
    legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
                                        int
                                        check_adslAturThreshFastRateUp(int
                                                                       type,
                                                                       u_long
                                                                       *
                                                                       val,
                                                                       size_t
                                                                       val_len,
                                                                       u_long
                                                                       *
                                                                       old_val,
                                                                       size_t
                                                                    old_val_len)
                                        {

                                        int ret;
    /** Check to see that we were called legally */
                                        if (!val)
                                        return SNMP_ERR_GENERR;
    /** Check the incoming type for correctness */
                                        if (type != ASN_UNSIGNED)
                                        return SNMP_ERR_WRONGTYPE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the adslAturThreshInterleaveRateUp mib node
     is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
                                        int
                                        check_adslAturThreshInterleaveRateUp
                                        (int type, u_long * val,
                                         size_t val_len, u_long * old_val,
                                         size_t old_val_len) {

                                        int ret;
    /** Check to see that we were called legally */
                                        if (!val)
                                        return SNMP_ERR_GENERR;
    /** Check the incoming type for correctness */
                                        if (type != ASN_UNSIGNED)
                                        return SNMP_ERR_WRONGTYPE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the adslAturThreshFastRateDown mib node is
    legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
                                        int
                                        check_adslAturThreshFastRateDown
                                        (int type, u_long * val,
                                         size_t val_len, u_long * old_val,
                                         size_t old_val_len) {

                                        int ret;
    /** Check to see that we were called legally */
                                        if (!val)
                                        return SNMP_ERR_GENERR;
    /** Check the incoming type for correctness */
                                        if (type != ASN_UNSIGNED)
                                        return SNMP_ERR_WRONGTYPE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the adslAturThreshInterleaveRateDown mib
    node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
                                        int
                                        check_adslAturThreshInterleaveRateDown
                                        (int type, u_long * val,
                                         size_t val_len, u_long * old_val,
                                         size_t old_val_len) {

                                        int ret;
    /** Check to see that we were called legally */
                                        if (!val)
                                        return SNMP_ERR_GENERR;
    /** Check the incoming type for correctness */
                                        if (type != ASN_UNSIGNED)
                                        return SNMP_ERR_WRONGTYPE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the adslLineAlarmConfProfileRowStatus mib
    node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
                                        int
                                        check_adslLineAlarmConfProfileRowStatus
                                        (int type, long *val,
                                         size_t val_len, long *old_val,
                                         size_t old_val_len) {

                                        int ret;
    /** Check to see that we were called legally */
                                        if (!val)
                                        return SNMP_ERR_GENERR;
    /** Check the incoming type for correctness */
                                        if (type != ASN_INTEGER)
                                        return SNMP_ERR_WRONGTYPE;
    /** Check the enums.  Legal values will continue, others return error. */
                                        switch (*val) {
case ADSLLINEALARMCONFPROFILEROWSTATUS_ACTIVE:
case ADSLLINEALARMCONFPROFILEROWSTATUS_NOTINSERVICE:
case ADSLLINEALARMCONFPROFILEROWSTATUS_NOTREADY:
case ADSLLINEALARMCONFPROFILEROWSTATUS_CREATEANDGO:
case ADSLLINEALARMCONFPROFILEROWSTATUS_CREATEANDWAIT:
case ADSLLINEALARMCONFPROFILEROWSTATUS_DESTROY:
                                        break;
    /** not a legal enum value.  return an error */
default:
                                        return SNMP_ERR_INCONSISTENTVALUE;}
                                        ret = SNMP_ERR_NOERROR;
                                        if (ret =
                                          check_rowstatus_transition((old_val) ?
                                           *old_val : RS_NONEXISTENT, *val))
                                        return ret;
}
#endif

/** Decides if an incoming value for the adslAtucInitFailureTrapEnable mib node
    is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
                        int
                        check_adslAtucInitFailureTrapEnable(int type,
                                                            long *val,
                                                            size_t val_len,
                                                            long *old_val,
                                                            size_t
                                                            old_val_len) {

                        int ret;
    /** Check to see that we were called legally */
                        if (!val)
                        return SNMP_ERR_GENERR;
    /** Check the incoming type for correctness */
                        if (type != ASN_INTEGER)
                        return SNMP_ERR_WRONGTYPE;
    		/** Check the enums.  Legal values will continue, others return error. */
                        switch (*val) {
			  case ADSLATUCINITFAILURETRAPENABLE_ENABLE:
			  case ADSLATUCINITFAILURETRAPENABLE_DISABLE:
                            break;
    		/** not a legal enum value.  return an error */
			  default:
                        	return SNMP_ERR_INCONSISTENTVALUE;
			}
                  	return SNMP_ERR_NOERROR;
}


