/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : IFX-IIP-LAN-MIB
 *        Creator : Sharon Tseng
 *        File    : ifxDnsConfTable_access.c
 *        Abstract: 
 *                  
 *        Date    : 24-May-2005
 *        Ref. Doc: IIP-DFS.doc
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.9 2004/10/14 12:57:33 dts12 Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "ifxDnsConfTable_access.h"

/*
 * ===========================================================================
 *                          GLOBAL DEFINITIONS
 * ===========================================================================
*/
static char                 cRetVal[MAX_DATA_LEN];
static unsigned int         nEntryNum = 1;

/*
 * ===========================================================================
 *                          LOCAL FUNCTIONS
 * ===========================================================================
*/
netsnmp_variable_list *
ifxDnsConfTable_set_indexes(DNSCFG_S *datainfo,
                              netsnmp_variable_list *put_index_data)
{
    /* printf("**** ifxDnsConfTable_set_indexes ****\n"); */
    netsnmp_variable_list   *vptr;

    vptr = put_index_data;
    snmp_set_var_value(vptr, (u_char *) &datainfo->index,
                       sizeof(datainfo->index) );

    return put_index_data;
}

DNSCFG_S **
ifxDnsConfTable_get_data(void)
{
    int              i = 0;

    if (nEntryNum > 0)
    {
        memset (&xMibMsg, 0x00, sizeof(IFX_MIB_MSG_S));
        xMibMsg.nType = IFX_MIB_WAN_DNS;
        xMibMsg.nCount = nEntryNum;
        xMibMsg.nPSize = sizeof(DNSCFG_S *);
        xMibMsg.nSize = sizeof(DNSCFG_S);

        ifx_MIB_Dalloc();
	}

    for ( i = 0; i < nEntryNum; i++)
    {
        memset (&cRetVal, 0x00, MAX_DATA_LEN);
        pstWanDnsCfg[i]->index = i;
    
    	if (ifx_GetCfgData(FILE_RC_CONF, "wan_dns", "dns1", cRetVal) != 1)
    	{
            DEBUGMSGTL(("snmpd", "unable get Primary WAN DNS\n"));
    	}
    	strcpy (pstWanDnsCfg[i]->cPriServerMAC ,cRetVal);
    
        memset (&cRetVal, 0x00, MAX_DATA_LEN);
    
    	if (ifx_GetCfgData(FILE_RC_CONF, "wan_dns", "dns2", cRetVal) != 1)
    	{
            DEBUGMSGTL(("snmpd", "unable get Secondary WAN DNS\n"));
    	}
    	strcpy (pstWanDnsCfg[i]->cSecServerMAC ,cRetVal);
    }
}

/** returns the first data point within the ifxDnsConfTable table data.

    Set the my_loop_context variable to the first data point structure
    of your choice (from which you can find the next one).  This could
    be anything from the first node in a linked list, to an integer
    pointer containing the beginning of an array variable.

    Set the my_data_context variable to something to be returned to
    you later that will provide you with the data to return in a given
    row.  This could be the same pointer as what my_loop_context is
    set to, or something different.

    The put_index_data variable contains a list of snmp variable
    bindings, one for each index in your table.  Set the values of
    each appropriately according to the data matching the first row
    and return the put_index_data variable at the end of the function.
*/
netsnmp_variable_list *
ifxDnsConfTable_get_first_data_point(void **my_loop_context,
                                     void **my_data_context,
                                     netsnmp_variable_list *
                                     put_index_data,
                                     netsnmp_iterator_info *mydata)
{
    /* printf("**** ifxDnsConfTable_get_first_data_point ****\n"); */
    int     *position;

    /* we could do this with a file-static variable, but for learning
       purposes we'll use memory allocation to demonstrate simplistic
       freeing of a loop_context */
    position = (int *)malloc(sizeof(int));
    if (!position)
        return NULL;

    ifxDnsConfTable_get_data();

    if (!pstWanDnsCfg)
    {
        snmp_log(LOG_ERR, "ifxDnsConfTable: None of row for this table.\n");
        free(position);
        return NULL;
    }

    /* We use the positinonal count as our loop context */
    *position = 0;
    *my_loop_context = position;

    /* our data context is the individual array element, in this case
       it's the first. */
    *my_data_context = pstWanDnsCfg[*position];

    /* now, save the index data into the passed in (linked list) pointer */
    return ifxDnsConfTable_set_indexes(pstWanDnsCfg[*position], put_index_data);
}

/** functionally the same as ifxDnsConfTable_get_first_data_point, but
   my_loop_context has already been set to a previous value and should
   be updated to the next in the list.  For example, if it was a
   linked list, you might want to cast it to your local data type and
   then return my_loop_context->next.  The my_data_context pointer
   should be set to something you need later and the indexes in
   put_index_data updated again. */
netsnmp_variable_list *
ifxDnsConfTable_get_next_data_point(void **my_loop_context,
                                    void **my_data_context,
                                    netsnmp_variable_list * put_index_data,
                                    netsnmp_iterator_info *mydata)
{
    /* printf("**** ifxDnsConfTable_get_next_data_point ****\n"); */
    int *position = (int *) *my_loop_context;

    /* make sure we were called correctly */
    if (!position)
        return NULL;
    
    /* go to the next entry in the list */
    (*position)++;

    /* Are we beyond the end? */
    if (*position >= nEntryNum)
    {
        /* End of entry.  stop here by returning NULL */
        free(position);
        *my_loop_context = NULL;
        *my_data_context = NULL;
        return NULL;
    }

    /* our data context is the individual array element, in this case
       it's the first. */
    *my_data_context = pstWanDnsCfg[*position];

    /* now, save the index data into the passed in (linked list) pointer */
    return ifxDnsConfTable_set_indexes(pstWanDnsCfg[*position], put_index_data);
}

/** Create a data_context for non-existent rows that SETs are performed on.
 *  return a void * pointer which will be passed to subsequent get_XXX
 *  and set_XXX functions for data retrival and modification during
 *  this SET request.
 *
 *  The indexs are encoded (in order) into the index_data pointer if it
 *  would be helpful to use that information.
 */
void           *
ifxDnsConfTable_create_data_context(netsnmp_variable_list *index_data,
                                    int column)
{
    return NULL;                /* XXX: you likely want to return a real pointer */
}

/** If the implemented set_* functions don't operate directly on the
   real-live data (which is actually recommended), then this function
   can be used to take a given my_data_context pointer and "commit" it
   to whereever the modified data needs to be put back to.  For
   example, if this was a routing table you could publish the modified
   routes back into the kernel at this point.

   new_or_del will be set to 1 if new, or -1 if it should be deleted
   or 0 if it is just a modification of an existing row.

   If you free the data yourself, make sure to *my_data_context = NULL */
int
ifxDnsConfTable_commit_row(void **my_data_context, int new_or_del)
{
    DNSCFG_S  *datactx = *my_data_context;
    char    sDNS1[MAX_DATA_LEN], sDNS2[MAX_DATA_LEN];
    int                     nSetReturn = -1;

    /* printf("**** ifxDnsConfTable_commit_row ****\n"); */

    if (new_or_del == -1)
        return SNMP_ERR_NOERROR; /* no change in the value */

    memset (&sDNS1, 0x00, MAX_DATA_LEN);
    sprintf(sDNS1, "dns1=\"%s\"", &datactx->cPriServerMAC);

    memset (&sDNS2, 0x00, MAX_DATA_LEN);
    sprintf(sDNS2, "dns2=\"%s\"", &datactx->cSecServerMAC);
    nSetReturn = websSetCfgData(FILE_RC_CONF, "wan_dns", 2, sDNS1, sDNS2);

    if (nSetReturn != 1)
    {
        return SNMP_ERR_COMMITFAILED;
    }

    return SNMP_ERR_NOERROR;
}


/*
 * User-defined data access functions (per column) for data in table ifxDnsConfTable 
 */
/*
 * NOTE:
 * - these get_ routines MUST return data that will not be freed (ie,
 *   use static variables or persistent data).  It will be copied, if
 *   needed, immediately after the get_ routine has been called.
 * - these SET routines must copy the incoming data and can not take
 *   ownership of the memory passed in by the val pointer.
 */
/** XXX: return a data pointer to the data for the dnsPrimaryServer column and set
         ret_len to its proper size in bytes. */
char           *
get_dnsPrimaryServer(void *data_context, size_t * ret_len)
{
    DNSCFG_S   *datainfo = data_context;
	*ret_len = strlen(datainfo->cPriServerMAC);
    return (char *) &datainfo->cPriServerMAC;
}

/** XXX: Set the value of the dnsPrimaryServer column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_dnsPrimaryServer(void *data_context, char *val, size_t val_len)
{
    DNSCFG_S *datainfo = data_context;
    memset(&datainfo->cPriServerMAC, 0x00, sizeof(datainfo->cPriServerMAC));
    memcpy(&datainfo->cPriServerMAC, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the dnsSecondaryServer column and set
         ret_len to its proper size in bytes. */
char           *
get_dnsSecondaryServer(void *data_context, size_t * ret_len)
{
    DNSCFG_S   *datainfo = data_context;
	*ret_len = strlen(datainfo->cSecServerMAC);
    return (char *) &datainfo->cSecServerMAC;
}

/** XXX: Set the value of the dnsSecondaryServer column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_dnsSecondaryServer(void *data_context, char *val, size_t val_len)
{
    DNSCFG_S *datainfo = data_context;
    memset(&datainfo->cSecServerMAC, 0x00, sizeof(datainfo->cSecServerMAC));
    memcpy(&datainfo->cSecServerMAC, val, val_len);
    return SNMP_ERR_NOERROR;
}
