/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : IFX-IIP-QOS-MIB
 *        Creator : Sharon Tseng
 *        File    : ifxQosSwEnhanceTable_checkfns.c
 *        Abstract: 
 *                  
 *        Date    : 24-May-2005
 *        Ref. Doc: IIP-DFS.doc
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.check_values.conf,v 1.6 2003/06/13 18:18:04 hardaker Exp $
 */

/********************************************************************
 *                       NOTE   NOTE   NOTE
 *   This file is auto-generated and SHOULD NOT BE EDITED by hand.
 *   Modify the ifxQosSwEnhanceTable_checkfns_local.[ch] files insead so that you
 *   can regenerate this one as mib2c improvements are made.
 ********************************************************************/

/*
 * standard headers 
 */
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <ifxCommon/ifxMIB_common.h>
#include "ifxQosSwEnhanceTable_checkfns.h"

/** Decides if an incoming value for the qosPortType mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_qosVID(int type, int *val, size_t val_len,
                int *old_val, size_t old_val_len)
{
    int ret, i = 0;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;
    /** Check the incoming type for correctness */
    if (type != ASN_INTEGER)
        return SNMP_ERR_WRONGTYPE;

    if (!(*val >= 0 && *val <= 4095) )
    {
        snmp_log(LOG_ERR, "qosVID: Please refer to the related MIB file.\n");
        return SNMP_ERR_WRONGVALUE;
    }

    if (pstQosSwEnCfg && xMibMsg.nType == IFX_MIB_QOS_SWENHANCE)
    {
        for (i = 0 ; i < xMibMsg.nCount; i++)
        {
            if (*val == pstQosSwEnCfg[i]->nVID)
            {
                snmp_log(LOG_ERR, "qosVID: Please refer to the related MIB file.\n");
                return SNMP_ERR_WRONGVALUE;
            }
        }
    }

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the qosAccLAN mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_qosAccLAN(int type, int *val, size_t val_len,
                    int *old_val, size_t old_val_len)
{
    int ret;
    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;
    /** Check the incoming type for correctness */
    if (type != ASN_INTEGER)
        return SNMP_ERR_WRONGTYPE;

   return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the qosAccPC mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_qosAccPC(int type, int *val, size_t val_len,
                int *old_val, size_t old_val_len)
{
    int ret;
    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;
    /** Check the incoming type for correctness */
    if (type != ASN_INTEGER)
        return SNMP_ERR_WRONGTYPE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the qosAccIPP mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_qosAccIPP(int type, int *val, size_t val_len,
                int *old_val, size_t old_val_len)
{
    int ret;
    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;
    /** Check the incoming type for correctness */
    if (type != ASN_INTEGER)
        return SNMP_ERR_WRONGTYPE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the qosEgrLAN mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_qosEgrLAN(int type, int *val, size_t val_len,
                int *old_val, size_t old_val_len)
{
    int ret;
    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;
    /** Check the incoming type for correctness */
    if (type != ASN_INTEGER)
        return SNMP_ERR_WRONGTYPE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the qosEgrPC mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_qosEgrPC(int type, int *val, size_t val_len,
                int *old_val, size_t old_val_len)
{
    int ret;
    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;
    /** Check the incoming type for correctness */
    if (type != ASN_INTEGER)
        return SNMP_ERR_WRONGTYPE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the qosEgrIPP mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_qosEgrIPP(int type, int *val, size_t val_len,
                int *old_val, size_t old_val_len)
{
    int ret;
    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;
    /** Check the incoming type for correctness */
    if (type != ASN_INTEGER)
        return SNMP_ERR_WRONGTYPE;

    return SNMP_ERR_NOERROR;
}
