/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : IFX-IIP-VOIP-MIB
 *        Creator : Sharon Tseng
 *        File    : ifxVoIPMIB.h
 *        Abstract: This file contains the command 'config_require' and module
 *                  names which will be used the configure script to generate a
 *                  Makefile. This file is used by the configure script to load
 *                  the different modules under ifxVoIPMIB directory for compilation.
 *
 *        Date    : 24-May-2005
 *        Ref. Doc: IIP-DFS.doc
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

// This file is included in the mibgroup directory to add the various modules
// of RTP

config_require(ifxVoIPMIB/ifxForeignKeyIdx/ifxForeignKeyIdx_access)

config_require(ifxVoIPMIB/ifxEndPointTable/ifxEndPointTable)
config_require(ifxVoIPMIB/ifxEndPointTable/ifxEndPointTable_access)
config_require(ifxVoIPMIB/ifxEndPointTable/ifxEndPointTable_checkfns)

config_require(ifxVoIPMIB/ifxSipUserTable/ifxSipUserTable)
config_require(ifxVoIPMIB/ifxSipUserTable/ifxSipUserTable_access)
config_require(ifxVoIPMIB/ifxSipUserTable/ifxSipUserTable_checkfns)

config_require(ifxVoIPMIB/ifxSipProxyTable/ifxSipProxyTable)
config_require(ifxVoIPMIB/ifxSipProxyTable/ifxSipProxyTable_access)
config_require(ifxVoIPMIB/ifxSipProxyTable/ifxSipProxyTable_checkfns)

config_require(ifxVoIPMIB/ifxSipRegTable/ifxSipRegTable)
config_require(ifxVoIPMIB/ifxSipRegTable/ifxSipRegTable_access)
config_require(ifxVoIPMIB/ifxSipRegTable/ifxSipRegTable_checkfns)

config_require(ifxVoIPMIB/ifxCodecTable/ifxCodecTable)
config_require(ifxVoIPMIB/ifxCodecTable/ifxCodecTable_access)
config_require(ifxVoIPMIB/ifxCodecTable/ifxCodecTable_checkfns)

config_require(ifxVoIPMIB/ifxCallFwTable/ifxCallFwTable)
config_require(ifxVoIPMIB/ifxCallFwTable/ifxCallFwTable_access)
config_require(ifxVoIPMIB/ifxCallFwTable/ifxCallFwTable_checkfns)

config_require(ifxVoIPMIB/ifxPhoneProfTable/ifxPhoneProfTable)
config_require(ifxVoIPMIB/ifxPhoneProfTable/ifxPhoneProfTable_access)
config_require(ifxVoIPMIB/ifxPhoneProfTable/ifxPhoneProfTable_checkfns)

config_require(ifxVoIPMIB/ifxMediaSecProfTable/ifxMediaSecProfTable)
config_require(ifxVoIPMIB/ifxMediaSecProfTable/ifxMediaSecProfTable_access)
config_require(ifxVoIPMIB/ifxMediaSecProfTable/ifxMediaSecProfTable_checkfns)

config_require(ifxVoIPMIB/ifxDtmfTable/ifxDtmfTable)
config_require(ifxVoIPMIB/ifxDtmfTable/ifxDtmfTable_access)
config_require(ifxVoIPMIB/ifxDtmfTable/ifxDtmfTable_checkfns)

config_require(ifxVoIPMIB/ifxJitBuffTable/ifxJitBuffTable)
config_require(ifxVoIPMIB/ifxJitBuffTable/ifxJitBuffTable_access)
config_require(ifxVoIPMIB/ifxJitBuffTable/ifxJitBuffTable_checkfns)

config_require(ifxVoIPMIB/ifxRtpPortRangeTable/ifxRtpPortRangeTable)
config_require(ifxVoIPMIB/ifxRtpPortRangeTable/ifxRtpPortRangeTable_access)
config_require(ifxVoIPMIB/ifxRtpPortRangeTable/ifxRtpPortRangeTable_checkfns)

config_require(ifxVoIPMIB/ifxTelUriTable/ifxTelUriTable)
config_require(ifxVoIPMIB/ifxTelUriTable/ifxTelUriTable_access)
config_require(ifxVoIPMIB/ifxTelUriTable/ifxTelUriTable_checkfns)

config_add_mib(IFX-IIP-VOIP-MIB)


