#!/bin/bash +x

TEST=
#TEST="echo "
VERSION=_R3
TARGET_NAME=generic_target
SNMP_ROOT=${VOBROOT}/vobs/Opera_Platform_Linux/Linux_BSP/ifx-com-linux/source/user/opensource/net-snmp-5.2.1


CHECKOUT_LIST="${SNMP_ROOT}/opera/${TARGET_NAME}${VERSION}/usr/lib/libIFXAPIs.so.0.0.0 \
${SNMP_ROOT}/opera/${TARGET_NAME}${VERSION}/usr/lib/libnetsnmpagent.so.5.2.1 \
${SNMP_ROOT}/opera/${TARGET_NAME}${VERSION}/usr/lib/libnetsnmphelpers.so.5.2.1 \
${SNMP_ROOT}/opera/${TARGET_NAME}${VERSION}/usr/lib/libnetsnmpmibs.so.5.2.1 \
${SNMP_ROOT}/opera/${TARGET_NAME}${VERSION}/usr/lib/libnetsnmp.so.5.2.1 \
${SNMP_ROOT}/opera/${TARGET_NAME}${VERSION}/usr/sbin/snmpd \
${SNMP_ROOT}/opera/${TARGET_NAME}${VERSION}/include/net-snmp/net-snmp-config.h \
${SNMP_ROOT}/opera/${TARGET_NAME}${VERSION}/include/net-snmp/agent/agent_module_config.h \
${SNMP_ROOT}/opera/${TARGET_NAME}${VERSION}/include/net-snmp/agent/mib_module_config.h \
${SNMP_ROOT}/opera/${TARGET_NAME}${VERSION}/include/net-snmp/library/snmpv3-security-includes.h \
${VOBROOT}/vobs/Opera_Platform_Linux/Linux_BSP/package/source/user/opensource/PreBuilt/${TARGET_NAME}${VERSION}/WP_COM/snmp.tgz"

function error_check {
	if [ $1 -ne 0 ]; then
		echo build failed aborting $1
		exit
	fi
}

function build_target {
	CHECKOUTS_OK=0
	TARGET=$1
	echo
	echo building for $TARGET
	for file in $CHECKOUT_LIST ; do
		subsfile=${file/${TARGET_NAME}/$TARGET}
		if [ ! -w $subsfile -a -e $subsfile ]; then
			echo checkout list  - fail:    $subsfile
			CHECKOUTS_OK=1
		else
			echo checkout list  - pass:    $subsfile
		fi
	done

	if [ $CHECKOUTS_OK -eq 1 ]; then
		echo You have missing checkouts...aborting
		exit
	else
		${TEST} make -f Makefile.opera OPERA_TARGET=${TARGET} clean
		error_check $?
		
		${TEST} make -f Makefile.opera OPERA_TARGET=${TARGET} OPERA_DEBUGINFO=YES
		error_check $?
	fi
}

build_target $1


